--[[============================================================================
main.lua
============================================================================]]--


-- Read from the manifest.xml file.
class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Mute note tracks")
    self:add_property("Id", "com.renoise.Mute_note_tracks")
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
local tool_name = manifest:property("Name").value
local tool_id = manifest:property("Id").value


--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------


local function toggle_track_mute()
  local mute_state = renoise.song().tracks[1].mute_state
   if mute_state == 1 then
    for _ = 1, #renoise.song().tracks do
      if renoise.song().tracks[_].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        renoise.song().tracks[_]:mute()
      end
     end
   else
    for _ = 1, #renoise.song().tracks do
      if renoise.song().tracks[_].type == renoise.Track.TRACK_TYPE_SEQUENCER then
        renoise.song().tracks[_]:unmute()
      end
     end
     
   end

  return 
end



--------------------------------------------------------------------------------
-- Menu entries
--------------------------------------------------------------------------------

renoise.tool():add_menu_entry {
  name = "Pattern Editor:"..tool_name.."...",
  invoke = toggle_track_mute  
}
renoise.tool():add_menu_entry {
  name = "Mixer:"..tool_name.."...",
  invoke = toggle_track_mute  
}


--------------------------------------------------------------------------------
-- Key Binding
--------------------------------------------------------------------------------

renoise.tool():add_keybinding {
  name = "Global:Tools:" .. tool_name.."...",
  invoke = toggle_track_mute
}


--------------------------------------------------------------------------------
-- MIDI Mapping
--------------------------------------------------------------------------------

renoise.tool():add_midi_mapping {
  name = tool_id..":Toggle note-track mute state...",
  invoke = toggle_track_mute
}

